VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Speed Testing"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text2 
      Height          =   270
      Left            =   2370
      TabIndex        =   9
      Top             =   465
      Width           =   1635
   End
   Begin VB.TextBox Text1 
      Height          =   270
      Left            =   2385
      TabIndex        =   7
      Top             =   135
      Width           =   1635
   End
   Begin VB.CommandButton cmdCollection 
      Caption         =   "Collection"
      Height          =   495
      Left            =   180
      TabIndex        =   2
      Top             =   2400
      Width           =   1215
   End
   Begin VB.CommandButton cmdDictionary 
      Caption         =   "Dictionary"
      Height          =   495
      Left            =   150
      TabIndex        =   1
      Top             =   1650
      Width           =   1215
   End
   Begin VB.CommandButton cmdArray 
      Caption         =   "Array"
      Height          =   495
      Left            =   180
      TabIndex        =   0
      Top             =   825
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Number of times to modify:"
      Height          =   270
      Left            =   120
      TabIndex        =   8
      Top             =   435
      Width           =   2310
   End
   Begin VB.Label Label1 
      Caption         =   "Number of items:"
      Height          =   270
      Left            =   150
      TabIndex        =   6
      Top             =   165
      Width           =   2310
   End
   Begin VB.Label lblCollection 
      Height          =   315
      Left            =   1650
      TabIndex        =   5
      Top             =   2505
      Width           =   2955
   End
   Begin VB.Label lblDictionary 
      Height          =   315
      Left            =   1650
      TabIndex        =   4
      Top             =   1755
      Width           =   2955
   End
   Begin VB.Label lblArray 
      Height          =   315
      Left            =   1665
      TabIndex        =   3
      Top             =   900
      Width           =   2955
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'This program tests array, collection, and dictionary speed.
'It adds a user-specified number of items to the object being tested
'(array, collection, or dictionary), modifies all the items in the
'object maxModify times, then removes the object.
'The total time it takes to perform all this,
'is timed, and displayed on-screen.
'Note that for a low number of modifications to the data,
'dictionaries appear best, but as you access or modify the data
'more, arrays clearly win out, even with the additional time
'up-front to find an empty array slot.

Private Max As Long
Private MaxModify As Long
Private i As Long, j As Long
Private Type MyArrayType
    InUse As Boolean
    Value As Long
End Type
Private mArray() As MyArrayType
Private mCol As Collection
Private mDict As Dictionary
Private FoundIt As Boolean
Private StartTime As Long
Private Declare Function timeGetTime Lib "winmm.dll" () As Long

Private Sub cmdArray_Click()
    StartTime = timeGetTime
    ReDim mArray(0 To 0) 'Always initialize 1 unused element 0 to avoid errors
    FoundIt = False
    For i = 1 To Max
    'Add a new item to the array
        'Find a blank slot
        For j = 1 To UBound(mArray, 1)
            If mArray(j).InUse = False Then
                'Found a blank slot - reuse it
                FoundIt = True
                Exit For
            End If
        Next j
        'If slot not found, create new one.
        If FoundIt = False Then
            'Allocate a new array slot
            j = UBound(mArray, 1) + 1
            ReDim Preserve mArray(0 To j)
        End If
        'Add item to slot
        mArray(j).InUse = True
        mArray(j).Value = i
    Next i
    For j = 1 To MaxModify
        For i = 1 To Max
            'Manipulate item in the array
            mArray(i).Value = i
        Next i
    Next j
    For i = 1 To Max
        'Remove item in the array
        mArray(i).InUse = False
    Next i
    lblArray.Caption = Format((timeGetTime - StartTime) / 1000, "#.00") & " seconds."
End Sub

Private Sub cmdCollection_Click()
    StartTime = timeGetTime
    Set mCol = New Collection
    'Add item to the collection
    For i = 1 To Max
        mCol.Add i
    Next i
    'Modify item in collection - can't modify, must remove and readd
    For j = 1 To MaxModify
        For i = 1 To Max
            mCol.Remove i
            mCol.Add i
        Next i
    Next j
    'Remove item from collection
    For i = 1 To Max
        mCol.Remove 1
    Next i
    lblCollection.Caption = Format((timeGetTime - StartTime) / 1000, "#.00") & " seconds."
End Sub

Private Sub cmdDictionary_Click()
    StartTime = timeGetTime
    Set mDict = New Dictionary
    'Add item to the dictionary
    For i = 1 To Max
        j = mDict.Count + 1
        mDict.Add j, i
    Next i
    'Modify item in the dictionary 500 times
    For j = 1 To MaxModify
        For i = 1 To Max
            mDict(i) = i
        Next i
    Next j
    'Remove item from the dictionary
    For i = 1 To Max
        mDict.Remove i
    Next i
    lblDictionary.Caption = Format((timeGetTime - StartTime) / 1000, "#.00") & " seconds."
End Sub

Private Sub Form_Load()
    Text1.Text = 500
    Text2.Text = 500
End Sub

Private Sub Text1_Change()
    Max = Val(Text1.Text)
End Sub

Private Sub Text2_Change()
    MaxModify = Val(Text2.Text)
End Sub
